<template>
  <q-dialog v-model="persistent" content-class="bg-grey-1" persistent transition-show="scale" transition-hide="scale">
    <q-card style="width: 600px;max-width:700px;">
      <q-card-section>
        <div class="text-h6">{{optionTitle}}</div>
      </q-card-section>
      <q-card-section class="q-pt-none scroll" style="max-height: 70vh">
        <div class="text-caption q-mb-lg q-px-md text-grey-6">月刊信息</div>
        <div class="row wrap" style="align-items:end;">
          <q-input filled stack-label maxlength="50" :dense="false" v-model="objOption.Name" class="col-12 q-pb-lg"
            label="月刊名称" ref="Name" :rules="[val => !!val || '请填写月刊名称']" />
          <q-input filled stack-label maxlength="200" :dense="false" v-model="objOption.LinkUrl" class="col-12 q-pb-lg"
            label="链接" />
          <div class="col-6 q-pb-lg q-pr-lg">
            <q-uploader :style="{ backgroundImage: 'url(' + objOption.CoverImg + ')' }"
              style="width:auto;height:200px;background-repeat:no-repeat;background-size:cover;" flat hide-upload-btn
              max-files="1" label="封面" accept=".jpg, image/*" :factory="uploadFile" auto-upload>
            </q-uploader>
          </div>
        </div>
      </q-card-section>
      <q-separator />
      <q-card-actions align="right" class="bg-white">
        <q-btn label="取消" flat color="grey-10" style="font-weight:400 !important" @click="closeSaveForm" />
        <q-btn label="立即提交" color="accent q-px-md" style="font-weight:400 !important" :loading="saveLoading"
          @click="saveComic" />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
  import {
    SetWebMonthly,
    GetWebMonthly
  } from '../../api/system/webkit'
  import {
    UploadSelfFile
  } from "../../api/common/common";
  export default {
    props: {
      saveObj: {
        type: Object,
        default: null
      }
    },
    data() {
      return {
        persistent: true,
        objOption: {
          Id: 0,
          Name: '',
          LinkUrl: '',
          CoverImg: '' //封面图
        },
        optionTitle: "新增月刊",
        saveLoading: false,
      }
    },
    mounted() {
      this.initObj()
    },
    methods: {
      //初始化表单
      initObj() {
        if (this.saveObj && this.saveObj.Id > 0) {
          GetWebMonthly({
            Id: this.saveObj.Id
          }).then(res => {
            if (res.Code == 1) {
              this.objOption.Id = res.Data.Id;
              this.objOption.Name = res.Data.Name;
              this.objOption.CoverImg = res.Data.CoverImg;
              this.objOption.LinkUrl = res.Data.LinkUrl;
              this.optionTitle = '修改月刊'
            }
          })
        }
      },
      uploadFile(files) {
        UploadSelfFile("course", files[0], res => {
          if (res.Code == 1) {
            this.objOption.CoverImg = res.FileUrl;
          }
        });
      },
      //关闭弹窗
      closeSaveForm() {
        this.$emit('close')
        this.persistent = false
      },
      //保存菜单
      saveComic() {
        this.$refs.Name.validate();
        if (!this.$refs.Name.hasError) {
          this.saveLoading = true
          SetWebMonthly(this.objOption).then(res => {
            this.saveLoading = false
            this.$q.notify({
              icon: 'iconfont icon-chenggong',
              color: 'accent',
              timeout: 2000,
              message: '数据保存成功！',
              position: 'top'
            })
            this.$emit("success")
            this.closeSaveForm()
          }).catch(() => {
            this.saveLoading = false
          })
        }
      }
    },
  }

</script>
